<?php
/**
*
* @author Stoker 4.0
* @package Top Stats
* @version $Id: install_top_stats.php, v1.0.8 20011/06/12 Stoker $
* @copyright (c) 2011 Stoker 4.0 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_name = 'TOP_STATS';

$version_config_name = 'top_stats_version';
$language_file = 'mods/umil_top_stats_install';

$versions = array(
	// Version 1.0.0
	'1.0.0'	=> array(
		'config_add' => array(
			array('tsrat_enable', 1),
			array('tsmvt_enable', 1),
			array('tsmrt_enable', 1),
			array('tsrat_number', 5),
			array('tsmvt_number', 5),
			array('tsmrt_number', 5),
			array('ts_jsscroll', 0),
		),
		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'TOP_STATS'),

			array('acp', 'TOP_STATS', array(
					'module_basename'	=> 'topstats',
					'module_langname'	=> 'TS_CONFIG',
					'module_mode'		=> 'overview',
					'module_auth'		=> 'acl_a_board',
				),
			),
		),
	),
	// Version 1.0.1
	'1.0.1' => array(
		// Nothing changed in this version.
	),
	// Version 1.0.2
	'1.0.2' => array(
			// Nothing changed in this version.
	),
	// Version 1.0.3
	'1.0.3' => array(
		'config_add' => array(
			array('tsjss_speed', 400),
			array('tsjss_interval', 4000),
		),
	),
	// Version 1.0.4
	'1.0.4' => array(
			// Nothing changed in this version.
	),
	// Version 1.0.5
	'1.0.5' => array(
		'config_add' => array(
			array('tsmau_enable', 1),
			array('tsmau_number', 5),
			array('tsmaf_enable', 1),
			array('tsmaf_number', 5),
			array('ts_jsscroll_direction', 1),
			array('ts_jsscroll_pause', 1),
			array('ts_jsscroll_navigation', 1),
			array('ts_ticker_enable', 0),
		),
	),
	// Version 1.0.6
	'1.0.6' => array(
			// Nothing changed in this version.
	),
	// Version 1.0.7
	'1.0.7' => array(
		'config_add' => array(
			array('tslvb_enable', 1),
			array('tslvb_number', 5),
			array('tslru_enable', 1),
			array('tslru_number', 5),
		),
		// purge the cache
		'cache_purge' => array(''),
	),
	// Version 1.0.8
	'1.0.8' => array(
		// Nothing changed in this version.
	),
	
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>